Summary: A tool for creating Scheme interfaces to C libraries
Name: g-wrap
Version: 1.3.4
Release: 5.1
Group: Development/Libraries
Copyright: GPL
Requires: guile
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prereq: /sbin/ldconfig
Source: ftp://ftp.gnucash.org/pub/g-wrap/g-wrap-%{version}.tar.gz
Patch0: g-wrap-info.patch
BuildPrereq: guile-devel umb-scheme

%description
This is a tool for specifying types, functions, and constants to
import into a Scheme interpreter, and for generating code (in C) to
interface these to the Guile and RScheme interpreters in particular.

%package devel
Summary: Include files and libraries needed for g-wrap development.
Group: Development/Libraries
Prereq: /sbin/install-info
Requires: g-wrap = %{version}, guile-devel

%description devel
g-wrap-devel contains development libraries and headers for g-wrap.

You can provide access to a given C API by creating a specification
file describing the interface you want published at the Scheme level.
g-wrap will handle generating all the lower level library interface
code so that the C library shows up as a set of Scheme functions.

You should install g-wrap-devel if you need to compile programs that
need to use g-wrap C<->Scheme functionality

%prep
%setup -q
%patch0 -p1
%build
#cp /usr/share/libtool/config.{sub,guess} .

%configure
make

%ifnarch s390x ppc64
make check
%endif

%install
rm -rf %{buildroot}
%makeinstall

/sbin/ldconfig -n %{buildroot}/usr/share/guile/g-wrapped

rm -f %{buildroot}/usr/share/info/dir

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig

%post devel
/sbin/install-info \
    --info-dir=%{_infodir} %{_infodir}/g-wrap.info.gz

%postun -p /sbin/ldconfig

%postun devel
if [ "$1" = "0" ]; then
    /sbin/install-info --delete \
	--info-dir=%{_infodir} %{_infodir}/g-wrap.info.gz
fi

%files
%defattr(-,root,root)
%doc AUTHORS COPYING.LIB ChangeLog INSTALL NEWS README THANKS
%{_libdir}/*.so.*
%{_libdir}/*.la
%{_datadir}/guile/g-wrap
%{_datadir}/guile/*.scm

%files devel
%defattr(-,root,root)
%{_bindir}/*
%{_libdir}/*.so
%{_libdir}/*.a
%{_includedir}/*
%{_datadir}/aclocal/g-wrap.m4
%doc %{_infodir}/g-wrap.info*

%changelog
* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Jun 18 2003 Bill Nottingham <notting@redhat.com> 1.3.4-4
- don't run make check on x86_64, it doesn't like new guile

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Jan 14 2003 Bill Nottingham <notting@redhat.com> 1.3.4-2
- move .la files to main package (#79068)

* Mon Dec 23 2002 Bill Nottingham <notting@redhat.com> 1.3.4-1
- update to 1.3.4

* Wed Dec  4 2002 Bill Nottingham <notting@redhat.com> 1.3.2-2
- rebuild (self hosting? what's that?)

* Tue Dec  3 2002 Bill Nottingham <notting@redhat.com> 1.3.2-1
- update to 1.3.2

* Tue Dec  3 2002 Bill Nottingham <notting@redhat.com> 1.2.1-9
- rebuild against new guile

* Mon Nov 11 2002 Tim Powers <timp@redhat.com> 1.2.1-8
- rebuild to fix broken deps

* Wed Nov  6 2002 Bill Nottingham <notting@redhat.com> 1.2.1-7
- unautomated rebuild
- make it self-host (#71614)

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Apr  8 2002 Bill Nottingham <notting@redhat.com>
- rebuild against fixed guile

* Thu Feb 21 2002 Bill Nottingham <notting@redhat.com>
- rebuild

* Tue Jan 29 2002 Bill Nottingham <notting@redhat.com>
- rebuild, thwack dependencies

* Fri Jan 25 2002 Bill Nottingham <notting@redhat.com>
- rebuild against new guile, update to 1.2.1

* Thu Jan 24 2002 Bill Nottingham <notting@redhat.com>
- rebuild

* Fri Aug  9 2001 Bill Nottingham <notting@redhat.com>
- fix builds for users without /sbin in their path

* Wed Aug  8 2001 Bill Nottingham <notting@redhat.com>
- fix build
- put a .so link in the g-wrapped directory in the main package (fixes #51129)

* Fri Jul  6 2001 Bill Nottingham <notting@redhat.com>
- tweak dependencies

* Wed Jun 27 2001 Bill Nottingham <notting@redhat.com>
- add info dir entry

* Wed Jun  6 2001 Bill Nottingham <notting@redhat.com>
- update to 1.1.10
- split out devel package

* Tue Aug 1 2000 Tim Powers <timp@redhat.com>
- fixed group to be a valid one
- fix bug #15038

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Tue Jul 11 2000 Tim Powers <timp@redhat.com>
- rebuilt

* Wed Jul 05 2000 Preston Brown <pbrown@redhat.com>
- adopted for Powertools 7.1
